package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class EntradaDeEstoquePage extends PageBase {

        //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
        //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

        //FILTRO INICIAL:
        By clearFilter = By.xpath("//*[@data-zh-id='681099116922975830150_filter_action_clear']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='6810991164021547667197']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
        By btnIconAlmoxarifado1 = By.xpath("//*[@data-zh-id='68109911634602156202']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id
        By btnXlimparDataEntradaEstFiltro = By.xpath("//*[@data-zh-id='6810991163743328191960']//*[@zh-icon='no-border close-x']");
        By IconeData = By.xpath("//*[@data-zh-id='6810991163743328191960']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
        By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
        By aplicarFiltro = By.xpath("//*[@data-zh-id='681099116922975830150_filter_action_never']//span[text() = 'Aplicar filtro']"); //data-zh-id esta vazio

        //ADICIONAR ENTRADA DE ESTOQUE:
        By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='6810991163208020097228']");
        By btnXlimparDataEntrada = By.xpath("//*[@data-zh-id='68109911641263904779']//*[@zh-icon='no-border close-x']");
        By IconeData2 = By.xpath("//*[@data-zh-id='68109911641263904779']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEntrada = By.xpath("//*[@id='zh-calendar-Widget']//*[@class='day today']");
        By campoDescricao = By.xpath("//*[@zh-id='681099116909717241781']");
        By btnAdicionar2 = By.xpath("//*[@id='footer']//*[@data-zh-id='6810991163334385738170']");
        By btnIconProduto = By.xpath("//*[@data-zh-id='6810991164266606876154']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto = By.xpath("//span[text()='SUMO DE LIMAO - CX12 500ML']");

        //Informações Complementares do Produto
        By btnIconLimparAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-close-x zh-icon-no-border']");
        By btnIconProcurarAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By campoLote = By.xpath("//*[@data-zh-id='7645275171631791325304']//input");

        By btnCalendario2 = By.xpath("//*[@data-zh-id='76452751786488369316']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaAtual = By.xpath("//*[@class='day today']");//Nao precisa de data-zh-id
        By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");
        By caixaDeDialogo = By.xpath("//span[text()='Sim']");

        //sub-aba Produtos:
        By campoQuantidade = By.xpath("//*[@zh-id='6810991161502326140163']");
        By campoValorUnitario = By.xpath("//*[@zh-id='6810991162722361895168']");

        //salvar Item:
        By salvarItem = By.xpath("//*[@data-zh-id='6810991163713795285178']");

        //salvar Item:
        By salvarLancamento = By.xpath("//*[@data-zh-id='6810991163466019639828']");


    //Editar
    By Btnlancamento = By.xpath("//span[text()='Teste Automatizado']");
    By produto2 = By.xpath("//span[text()='Hela Poultry Broth Paste Clear KG']");
    By editar = By.xpath("//*[@data-zh-id='68109911648462699172']");
    By campoDescricao2 = By.xpath("//*[@zh-id='681099116909717241781']");
    By salvarItem2 = By.xpath("//span[text()='Salvar Item']");


    //Deletar
    By btnSim = By.xpath("//span[text()='Sim']");
    By Btnlancamento2 = By.xpath("//span[text()='Deletar']");
    By excluir = By.xpath("//*[@data-zh-id='681099116401786073830']");

    //Banco
    By numerolancado = By.cssSelector(".row-editing > .td:nth-child(1) > span");
    By voltar = By.xpath("//span[text()='Voltar']");

    //FILTRO INICIAL:
    public void limparFilro(){
        waitForVisibilityOfElementLocated(clearFilter);
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //UNIDADE
    public void clicarCampoUnidade(){
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoBusca(){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }
    public void buscarUnidade(String descUnidade){
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarUnidade(){
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado1);
        click(btnIconAlmoxarifado1);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarAlmoxarifado(String descAlmoxarifado){
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarAlmoxarifado(){
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Data
    public void limparCampoData(){
        waitForVisibilityOfElementLocated(btnXlimparDataEntradaEstFiltro);
        click(btnXlimparDataEntradaEstFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoData(){
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void escolherData(){
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automaticamente.
    }
    public void clicarFiltroOK(){
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Aplicar Filtro
    public void aplicarFiltro(){
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    //Adicionar
    public void clicarBotaoAdicionar(){
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void limparDataEntrada(){
        waitForVisibilityOfElementLocated(btnXlimparDataEntrada);
        click(btnXlimparDataEntrada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarDataEntrada(){
        waitForVisibilityOfElementLocated(IconeData2);
        click(IconeData2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoDataEntrada(){
        waitForVisibilityOfElementLocated(DataEntrada);
        click(DataEntrada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Descrição
    public void clicarCampoDescricao(String cmpDesc){
        waitForVisibilityOfElementLocated(campoDescricao);
        click(campoDescricao);
        sendKeys(campoDescricao, cmpDesc);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Adicionar
    public void clicarAdicionarProduto(){
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Produto
    public void clicarCampoProduto(){
        waitForVisibilityOfElementLocated(btnIconProduto);
        click(btnIconProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void digitarCampoPrduto(String descProduto){
        sendKeys(campoProcurarFloatControl, descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void  selecionarProduto(){
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Campo Informações Complementares do Produto
    public void limparCampoAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnIconLimparAlmoxarifado);
        click(btnIconLimparAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarAlmoxarifado(){
        waitForVisibilityOfElementLocated(btnIconProcurarAlmoxarifado);
        click(btnIconProcurarAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //lote:
    public void selecionarLote(String DescCampoLote){
        waitForVisibilityOfElementLocated(campoLote);
        click(campoLote);
        sendKeys(campoLote, DescCampoLote);
    }
//Calendário
    public void  clicarCalendario(){
        waitForVisibilityOfElementLocated(btnCalendario2);
        click(btnCalendario2);
    }

    public void escolherDataAtual(){
        waitForVisibilityOfElementLocated(DataEscolhidaAtual);
        click(DataEscolhidaAtual);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    //btn confirmar
    public void clicarConfirmar(){
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //sub-aba Produtos:

    //Caixa de dialogo

    public void clicarCaixaDialogoSim(){
        waitForVisibilityOfElementLocated(caixaDeDialogo);
        click(caixaDeDialogo);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Quantidade
    public void quantidadeEscolhida(String quantidade){
        waitForVisibilityOfElementLocated(campoQuantidade);
        sendKeys(campoQuantidade, quantidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Valor Unitario
    public void inserirValorUnitario(String valorUnitario){
        waitForVisibilityOfElementLocated(campoValorUnitario);
        clear(campoValorUnitario);
        sendKeys(campoValorUnitario, valorUnitario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Salvar Item
    public void clicarSalvarItem(){
        waitForVisibilityOfElementLocated(salvarItem);
        click(salvarItem);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //Salvar Lançamento:
    public void clicarSalvarLancamento(){
        waitForVisibilityOfElementLocated(salvarLancamento);
        click(salvarLancamento);
        waitForInvisibilityOfElementLocated(loadingWait);
    }


    //Banco Captura
    public void bancoCaptura(){
       waitForVisibilityOfElementLocated(numerolancado);
        waitForVisibilityOfElementLocated(voltar);
        click(voltar);
    }

    //Banco tela de entrada
    public String retornaNumeroLacamento(){
       return  getText(numerolancado);
    }
    //Editar
    public void clicarEditar(){
        waitForVisibilityOfElementLocated(Btnlancamento);
        click(Btnlancamento);
    }
    public void campoDescricaoEditado(String cmpDesc2){
        waitForVisibilityOfElementLocated(campoDescricao2);
        click(campoDescricao2);
        clear(campoDescricao2);
        sendKeys(campoDescricao2, cmpDesc2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarBotaoAdicionarEdicao(){
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    //Produto Editado
    public void adicionarSegundoProduto(String cmpProduto) {
        sendKeys(campoProcurarFloatControl, cmpProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

    }



        public void selecionarSegundoProduto(){
            waitForVisibilityOfElementLocated(produto2);
            click(produto2);
            waitForInvisibilityOfElementLocated(loadingWait);
        }
        public void clicarSalvarItemEditado(){
        waitForVisibilityOfElementLocated(salvarItem2);
        click(salvarItem2);
        waitForInvisibilityOfElementLocated(loadingWait);
        }

    public void clicarEmSim(){
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);

    }

    //Excluir
    public void clicarLacamentoDeletar(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(Btnlancamento2);
        click(Btnlancamento2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
public void clicarExcluir() {
    waitForVisibilityOfElementLocated(excluir);
    click(excluir);

    waitForInvisibilityOfElementLocated(loadingWait);
}


    }

